##==============================================================
##                            t^D
##==============================================================
 lo <- matrix(c(135, 45, 15, 135, 45, 24, 135, 46, 31, 
     135, 45, 5, 135, 46, 35, 135, 45, 20, 135, 44, 48, 
     135, 42, 57, 135, 45, 41, 135, 48, 49, 135, 41, 36), 
     ncol = 3, byrow = TRUE)
##==============================================================
 la <- matrix(c(35, 2, 28, 35, 1, 47, 35, 1, 33, 35, 0, 
     36, 34, 59, 49, 34, 59, 15, 34, 58, 36, 35, 0, 37, 
     34, 56, 8, 34, 58, 21, 34, 59, 6), ncol = 3, byrow = TRUE)
 lola <- data.frame(longitude = lo[, 1] + lo[, 2]/60 + 
     lo[, 3]/360, latitude = la[, 1] + la[, 2]/60 + la[, 
     3]/360)
##==============================================================
 library(sp)
 cs <- CRS("+proj=longlat +datum=WGS84")
 kyoto.sp <- SpatialPoints(lola, proj4string = cs)
 kyoto.sp
##==============================================================
 n <- c("k", "㋞", "", 
     "", "R", "", 
     "", "E", "", 
     "Rȋ", "")
 kyoto.spdf <- SpatialPointsDataFrame(kyoto.sp, data = data.frame(n))
##==============================================================
 library(RColorBrewer)
 spplot(kyoto.spdf, col.regions = brewer.pal(11, "Set3"), 
     key.space = "right")
##==============================================================
 library(maptools)
 g <- readGPS(f = "/dev/ttyUSB0")
 g
##==============================================================
 g.sp <- SpatialPoints(data.frame(g$V7, g$V6))
##==============================================================
 g.df <- data.frame(name = g$V2, symbol = g$V5,
     elevation = as.numeric(sub("M", "", g$V17)))
 g.spdf <- SpatialPointsDataFrame(g.sp, data = g.df)
 spplot(g.spdf, zcol = "elevation", key.space = "right")
##==============================================================
 library(rgdal)
 dsn <- system.file("vectors/test_trk2.gpx", package = "rgdal")
 trk <- readOGR(dsn = dsn, layer = "track_points")
 class(trk)
 plot(trk)
##==============================================================
 L1 <- matrix(c(135.76, 35.1, 135.79, 35.11, 135.86, 35.12, 
     135.94, 35.02), ncol = 2, byrow = TRUE)
 L2 <- matrix(c(135.86, 35.12, 135.85, 35.11, 135.86, 
     35.1, 135.87, 35.07), ncol = 2, byrow = TRUE)
 L3 <- matrix(c(135.82, 35.15, 135.86, 34.96, 135.78, 
     35, 135.81, 35.02), ncol = 2, byrow = TRUE)
##==============================================================
 library(sp)
 L1.l <- Line(L1)
 L2.l <- Line(L2)
 L3.l <- Line(L3)
##==============================================================
 L1.ls <- Lines(list(L1.l, L2.l), ID = "1")
 L3.ls <- Lines(L3.l, ID = "3")
##==============================================================
 crs <- CRS("+proj=longlat +datum=WGS84")
 L.sp <- SpatialLines(list(L1.ls, L3.ls), proj4string = crs)
##==============================================================
 d <- data.frame(width = c(5, 10), row.names = c(1, 3))
 L.spdf <- SpatialLinesDataFrame(L.sp, data = d)
##==============================================================
 L.spdf@data$width <- factor(L.spdf@data$width)
##==============================================================
 p1 <- matrix(c(1, 2.4, 1.7, 3.1, 2.4, 2.4, 1.7, 1.7, 
     1, 2.4), byrow = TRUE, ncol = 2)
 p2 <- matrix(c(0.8, 2, 1, 2, 0.9, 1.5, 0.8, 2), byrow = TRUE, 
     ncol = 2)
 p3 <- matrix(c(-0.2, 1.7, 1, 2.4, 1.7, 1.7, 1, 1, -0.2, 
     1.7), byrow = TRUE, ncol = 2)
 p4 <- matrix(c(1, -0.3, 2, -0.3, 2, 1, 1.7, 1.7, 1, 1, 
     1, -0.3), byrow = TRUE, ncol = 2)
 class(p1)
##==============================================================
 library(sp)
 P1 <- Polygon(p1)
 P2 <- Polygon(p2, hole = TRUE)
 P3 <- Polygon(p3)
 P4 <- Polygon(p4)
 class(P1)
##==============================================================
 P1s <- Polygons(list(P1), ID = "1")
 P2s <- Polygons(list(P2, P3), ID = "3")
 P3s <- Polygons(list(P4), ID = "4")
 class(P1s)
##==============================================================
 SP <- SpatialPolygons(list(P1s, P2s, P3s))
 class(SP)
##==============================================================
 dat <- data.frame(name = LETTERS[1:3], v = runif(3))
 row.names(dat) <- c(1, 3, 4)
 dat
 SPDF <- SpatialPolygonsDataFrame(SP, data = dat)
 class(SPDF)
##==============================================================
 spplot(SPDF, zcol = "v")
##==============================================================
 library(maptools)
 writePolyShape(SPDF, fn = "spdf")
##==============================================================
 SPDF1 <- SPDF[1:2, ]
 SPDF2 <- SPDF[3, ]
##==============================================================
 plot(SPDF1)
 plot(SPDF2)
##==============================================================
 gpclibPermit()
 SPa <- unionSpatialPolygons(SP, IDs = c(1, 1, 1))
 SPb <- unionSpatialPolygons(SP, IDs = c(1, 1, 2))
##==============================================================
 plot(SPa)
 plot(SPb)
##==============================================================
 SPDF3 <- spRbind(SPDF1, SPDF2)
##==============================================================
 library(PBSmapping)
 data(nepacLL)
 m <- nepacLL[nepacLL$PID==33,]
 plotMap(m,xlab="Longitude",ylab="Latitude")
 m2 <- thickenPolys(m,tol=30,keepOrig=FALSE)
 plotMap(m2,xlab="Longitude",ylab="Latitude")
 m3 <- thinPolys(m,tol=3)
 plotMap(m3,xlab="Longitude",ylab="Latitude")
##==============================================================
 p1 <- nc[3, ]
 p2 <- nc[4, ]
 nc[["names"]][3:4]
 xlim <- c(min(p1@bbox[1, 1], p2@bbox[1, 1]), max(p1@bbox[1, 
     2], p2@bbox[1, 2]))
 ylim <- c(min(p1@bbox[2, 1], p2@bbox[2, 1]), max(p1@bbox[2, 
     2], p2@bbox[2, 2]))
 cols <- rep(gray(0.8), 100)
 cols[3:4] <- "red"
 plot(nc, xlim = xlim, ylim = ylim, col = cols)
##==============================================================
 nc.c <- coordinates(nc)
 (p.c <- nc.c[3:4, ])
 spDistsN1(p.c, p.c[1, ], longlat = TRUE)
##==============================================================
 p1.l <- Line(p1@polygons[[1]]@Polygons[[1]]@coords)
 p2.l <- Line(p2@polygons[[1]]@Polygons[[1]]@coords)
 n <- 500
 p1.pts = spsample(p1.l, n = n, type = "regular")
 p2.pts = spsample(p2.l, n = n, type = "regular")
 min(apply(coordinates(p1.pts), 1, function(p) {
     spDistsN1(coordinates(p2.pts), p, longlat = TRUE)
 }))
##==============================================================
 library(splancs)
 data(cardiff)
 dat <- data.frame(x = cardiff$x, y = cardiff$y,
      n = round(runif(length(cardiff$x), min = 1, max = 10)))
 head(dat)
##==============================================================
 library(deldir)
 s <- matrix(c(89.9, 28.9, 35.4, 7.9, 39.3, 87.2, 70.7, 
     12.3, 33, 23.3), ncol = 2)
 v <- deldir(s[, 1], s[, 2], rw = cardiff$area)
 plot(cardiff$poly, type = "l", xlab = "Easting", ylab = "Northing")
 plot(v, wline = "tess", pch = 19, cex = 2, add = TRUE)
 points(dat)
##==============================================================
 library(maptools)
 v.tl <- tile.list(v)
 tl2sp <- function(x) {
     chrjoin <- function(x) {
         y <- x[1]
         x <- x[-1]
         for (i in 1:length(x)) {
             y <- paste(y, x[1], sep = ",")
             x <- x[-1]
         }
         return(y)
     }
     ys <- paste("y", 1:length(x), sep = "")
     for (i in 1:length(x)) {
         y <- rbind(cbind(x[[i]]$x, x[[i]]$y), cbind(x[[i]]$x[1], 
             x[[i]]$y[1]))
         sy <- Polygons(list(Polygon(y)), paste("y", i))
         eval(parse(text = paste(ys[i], "<- sy")))
     }
     syy <- eval(parse(text = paste("list(", chrjoin(ys), 
         ")")))
     return(SpatialPolygons(syy))
 }
 v.sp <- tl2sp(v.tl)
 v.spdf <- SpatialPolygonsDataFrame(v.sp, data = data.frame(n = 1:5), 
     match.ID = FALSE)
 writePolyShape(v.spdf, fn = "v")
##==============================================================
 dat.sp <- SpatialPointsDataFrame(SpatialPoints(dat[, 
     1:2]), data = data.frame(dat[, 3]))
##==============================================================
 plot(cardiff$poly, type = "l", xlab = "Easting", ylab = "Northing", 
     xlim = c(0, 120), asp = 1)
 cols <- rev(heat.colors(10))
 plot(dat.sp, pch = 19, col = cols[dat.sp@data[, 1]], 
     add = TRUE)
 legend(100, 80, as.character(1:10), col = cols, pch = 19, 
     bty = "n")
 plot(v.spdf, add = TRUE)
##==============================================================
 res <- overlay(dat.sp, v.spdf, fn = sum)
 v.spdf@data <- cbind(v.spdf@data, pop = res[, 1])
 spplot(v.spdf, zcol = "pop")
##==============================================================
 grd <- GridTopology(cellcentre.offset = c(0.8, 4.8), 
     cellsize = c(10, 10), cells.dim = c(10, 10))
 grd.sp <- as.SpatialPolygons.GridTopology(grd)
##==============================================================
 plot(grd.sp, border = gray(0.8), xlim = c(0, 120))
 polygon(cardiff$poly)
 cols <- rev(heat.colors(10))
 plot(dat.sp, pch = 19, col = cols[dat.sp@data[, 1]], 
     add = TRUE)
 text(coordinates(grd.sp), getSpPPolygonsIDSlots(grd.sp), 
     cex = 0.5)
 legend(100, 80, as.character(1:10), col = cols, pch = 19, 
     bty = "n")
##==============================================================
 res <- overlay(dat.sp, grd.sp, fn = sum)
 ndx <- as.numeric(sub("X", "", row.names(res)))
 grd2.sp <- grd.sp[ndx, ]
 row.names(res) <- paste("g", ndx, sep = "")
 grd.spdf <- SpatialPolygonsDataFrame(grd2.sp, res)
 spplot(grd.spdf)
 writePolyShape(grd.spdf, fn = "grd")
##==============================================================
 w <- 10
 h <- 2 * w * cos(30 * (pi/180))
 x1.g <- seq(0.8, 100, by = w)
 y1.g <- seq(4.8, 100, by = h)
 x2.g <- x1.g + w/2
 y2.g <- y1.g + h/2
 crds <- as.matrix(rbind(expand.grid(x1.g, y1.g), expand.grid(x2.g, 
     y2.g)))
 v <- deldir(crds[, 1], crds[, 2])
 v.tl <- tile.list(v)
 v.sp <- tl2sp(v.tl)
##==============================================================
 plot(v.sp, border = gray(0.8), xlim = c(0, 120))
 polygon(cardiff$poly)
 cols <- rev(heat.colors(10))
 plot(dat.sp, pch = 19, col = cols[dat.sp@data[, 1]], 
     add = TRUE)
 legend(105, 80, as.character(1:10), col = cols, pch = 19, 
     bty = "n")
 text(coordinates(v.sp), getSpPPolygonsIDSlots(v.sp), 
     cex = 0.5)
##==============================================================
 res <- overlay(dat.sp, v.sp, fn = sum)
 ndx <- as.numeric(sub("X", "", row.names(res)))
 v2.sp <- v.sp[ndx, ]
 row.names(res) <- paste("y", ndx)
 v.spdf <- SpatialPolygonsDataFrame(v2.sp, res)
 l <- list("sp.text", coordinates(v2.sp), getSpPPolygonsIDSlots(v2.sp), 
     cex = 0.7)
 spplot(v.spdf, sp.layout = list(l))
 writePolyShape(v.spdf, fn = "h")
##==============================================================
 x <- runif(100)
 y <- runif(100)
 p.x <- c(0.3, 0.7, 0.5)
 p.y <- c(0.5, 0.5, 0.7)
 z <- point.in.polygon(x, y, p.x, p.y)
 cols <- c("blue", "red")
 plot(x, y, col = cols[z + 1], pch = 16)
 polygon(p.x, p.y)
