##==============================================================
##                            2
##==============================================================
 colorspaces
##==============================================================
 m <- outer(1:20, 1:20, function(x, y) sin(sqrt(x * y)/3))
 rgb.palette <- colorRampPalette(c("red", "orange", "blue"), 
     space = "rgb")
 Lab.palette <- colorRampPalette(c("red", "orange", "blue"), 
     space = "Lab")
 filled.contour(m, col = rgb.palette(20))
 filled.contour(m, col = Lab.palette(20))
##==============================================================
 print(palette())
 class(palette())
##==============================================================
 palette(gray((1:12)/12))
##==============================================================
 pie(rep(1, 12), col = 1:12)
##==============================================================
 palette(gray((1:48)/48))
 pie(rep(1, 48), col = 1:48)
##==============================================================
 palette("default")
##==============================================================
 palette(rainbow(12))
##==============================================================
 hcl(h = c(30, 110, 190, 270, 350), c = 20, l = 90)
##==============================================================
 library(maptools)
 pj <- CRS("+proj=longlat +ellps=clrk66")
 f <- system.file("shapes/sids.shp", package = "maptools")[1]
 nc <- readShapePoly(f, IDvar = "FIPSNO", proj4string = pj)
##==============================================================
 plot(coordinates(nc), asp = 1, xlab = "Longitude", ylab = "Latitude")
##==============================================================
 nc.b74 <- SpatialPointsDataFrame(SpatialPoints(coordinates(nc)), 
     data = data.frame(nc@data$BIR74))
 spplot(nc.b74)
##==============================================================
 bubble(nc.b74)
##==============================================================
 x1 <- seq(0, 1, 0.05)
 y1 <- c(sqrt(1 - x1^2) + 0.6 * sqrt(x1), rev(-sqrt(1 - 
     x1^2) + 0.6 * sqrt(x1)))
 h1 <- cbind(x = c(x1, rev(x1)), y = y1)
 h2 <- cbind(x = -rev(h1[, 1]), y = rev(h1[, 2]))
 heart <- rbind(h1, h2)
##==============================================================
 plot(heart, type = "n", asp = 1)
 polygon(heart, col = "red")
##==============================================================
 put.heart <- function(d) {
     x <- d[1]
     y <- d[2]
     s <- d[3]
     h <- heart * s
     h[, 1] <- h[, 1] + x
     h[, 2] <- h[, 2] + y
     polygon(h, col = "red")
 }
##==============================================================
 m <- 0.5
 d <- cbind(coordinates(nc), m * nc@data$BIR74/max(nc@data$BIR74))
 d <- d[order(d[, 3], decreasing = TRUE), ]
 head(d)
 plot(nc)
 apply(d, 1, put.heart)
 degAxis(1)
 degAxis(2, at = c(34, 35, 36, 37))
##==============================================================
 library(maptools)
 d <- dotsInPolys(nc, as.integer(nc@data$SID74))
 plot(nc, axes = TRUE)
 title(main = "SIDS 1974-78")
 plot(d, pch = 19, cex = 0.5, col = "red", add = TRUE)
##==============================================================
 d74 <- nc@data$SID74/nc@data$BIR74 * 1e+05
 d79 <- nc@data$SID79/nc@data$BIR79 * 1e+05
 summary(d74)
 summary(d79)
##==============================================================
 library(TeachingDemos)
 d <- cbind(d74, d79)
 d.m <- max(d)
 cols <- c(gray(0.3), gray(0.8))
 plot(nc)
 nc.c <- coordinates(nc)
 for (i in 1:nrow(nc.c)) {
     subplot(barplot(d[i, ], ylim = c(0, d.m), col = cols, 
         names = c("", ""), yaxt = "n"), x = nc.c[i, 1], 
         y = nc.c[i, 2], size = c(0.1, 0.5), vadj = 0)
 }
 legend(-83.5, 35, c("1974-1978", "1979-1984"), fill = cols, 
     bty = "n", cex = 0.8)
##==============================================================
 b1 <- nc@data$NWBIR74
 b2 <- nc@data$BIR74 - nc@data$NWBIR74
 plot(nc)
 for (i in 1:nrow(nc.c)) {
     subplot(pie(cbind(b1[i], b2[i]), col = cols, labels = c("", 
         "")), x = nc.c[i, 1], y = nc.c[i, 2], size = c(0.3, 
         0.3), vadj = 0.5)
 }
 legend(-83.5, 35, c("non-white", "white"), fill = cols, 
     bty = "n", cex = 0.8)
##==============================================================
 r <- sqrt(nc@data$BIR74/pi)
 r <- r/max(r) * 0.4
 plot(nc)
 for (i in 1:nrow(nc.c)) {
     subplot(pie(cbind(b1[i], b2[i]), col = cols, labels = c("", 
         "")), x = nc.c[i, 1], y = nc.c[i, 2], size = c(r[i], 
         r[i]), vadj = 0.5)
 }
 legend(-83.5, 35, c("non-white", "white"), fill = cols, 
     bty = "n", cex = 0.8)
##==============================================================
 library(maptools)
 x <- 10 * 1:nrow(volcano)
 y <- 10 * 1:ncol(volcano)
 clv <- contourLines(x, y, volcano)
 res <- ContourLines2SLDF(clv)
 grd <- GridTopology(c(0, 0), c(10, 10), dim(volcano))
 alt <- data.frame(altitude = as.vector((volcano[, ncol(volcano):1])))
 spvolcano <- SpatialGridDataFrame(grd, alt)
 spplot(spvolcano, sp.layout = list(list("sp.lines", res)))
##==============================================================
 spplot(nc, zcol = c("BIR74", "NWBIR74", "BIR79", "NWBIR79"), 
     names.attr = c("Births, 1974-78", "Non-white births, 1974-78", 
         "Births, 1979-84", "Non-white births, 1979-84"))
##==============================================================
 d74 <- nc@data$SID74/nc@data$BIR74 * 1e+05
 nc@data <- cbind(nc@data, d74)
 spplot(nc, zcol = "d74")
##==============================================================
 library(RColorBrewer)
 brks <- c(0, 200, 400, 600, 800, 1000)
 spplot(nc, zcol = "d74", at = brks, col.regions = brewer.pal(5, 
     "BuPu"))
##==============================================================
 z <- 2 * volcano
 x <- 10 * (1:nrow(z))
 y <- 10 * (1:ncol(z))
 persp(x, y, z, theta = 120, phi = 15, scale = FALSE, 
     axes = FALSE)
##==============================================================
 z0 <- min(z) - 20
 z <- rbind(z0, cbind(z0, z, z0), z0)
 x <- c(min(x) - 1e-10, x, max(x) + 1e-10)
 y <- c(min(y) - 1e-10, y, max(y) + 1e-10)
 fcol <- matrix("green3", nr = nrow(z) - 1, nc = ncol(z) - 
     1)
 i2 <- c(1, ncol(fcol))
 i1 <- c(1, nrow(fcol))
 fcol[, i2] <- "gray"
 fcol[i1, ] <- "gray"
 zi <- volcano[-1, -1] + volcano[-1, -61] + volcano[-87, 
     -1] + volcano[-87, -61]
 fcol[-i1, -i2] <- terrain.colors(20)[cut(zi, quantile(zi, 
     seq(0, 1, len = 21)), include.lowest = TRUE)]
 persp(x, y, 2 * z, theta = 120, phi = 15, col = fcol, 
     scale = FALSE, ltheta = -120, shade = 0.4, border = NA, 
     box = FALSE)
##==============================================================
 n <- length(nc@data$SID74)
 r <- 3
 s <- nc@data$SID74/nc@data$BIR74 * 1000/r
 require(RColorBrewer)
 cols <- rev(brewer.pal(11, "RdBu"))
 brks <- c(seq(0, max(s), length = 11), Inf)
 s.c <- cols[findInterval(s, brks)]
##==============================================================
 bb <- nc@bbox
 z <- matrix(c(0, 0, 0, 0), ncol = 2)
 p.m <- persp(bb[1, ], bb[2, ], z, scale = FALSE, zlim = c(0, 
     max(s)), theta = 25, phi = 35, r = 10, zlab = "SIDS morality", 
     ylab = "Latitude", xlab = "Longitude")
 for (i in 1:n) {
     xy <- nc@polygons[[i]]@Polygons[[1]]@coords
     xyz3d <- trans3d(xy[, 1], xy[, 2], s[i], p.m)
     polygon(xyz3d$x, xyz3d$y, col = s.c[i])
 }
##==============================================================
 n.arrow1 <- function(lx, ly, scale = 1, angle = 0) {
     if (missing(lx) | missing(ly)) 
         stop("No location was given")
     r <- c(0.5, 0.5, 0.2, 0.2, 0.2, 0.2, 0.6) * scale
     t <- c(3 * pi/2, pi/2, 3 * pi/4, pi/4, 5 * pi/4, 
         7 * pi/4, pi/2) + angle * pi/180
     x <- r * cos(t) + lx
     y <- r * sin(t) + ly
     lines(x[1:4], y[1:4])
     lines(x[5:6], y[5:6])
     text(x[7], y[7], "N", cex = scale)
 }
 plot(nc)
 n.arrow1(-83, 34.5, 0.7)
 plot(nc)
 n.arrow1(-83, 34.5, 0.7, 30)
##==============================================================
 northarrow <- function(loc, size, bearing = 0, cols, 
     cex = 1, ...) {
     if (missing(loc)) 
         stop("loc is missing")
     if (missing(size)) 
         stop("size is missing")
     if (missing(cols)) 
         cols <- rep(c("white", "black"), 8)
     radii <- rep(size/c(1, 4, 2, 4), 4)
     x <- radii[(0:15) + 1] * cos((0:15) * pi/8 + bearing) + 
         loc[1]
     y <- radii[(0:15) + 1] * sin((0:15) * pi/8 + bearing) + 
         loc[2]
     for (i in 1:15) {
         x1 <- c(x[i], x[i + 1], loc[1])
         y1 <- c(y[i], y[i + 1], loc[2])
         polygon(x1, y1, col = cols[i])
     }
     polygon(c(x[16], x[1], loc[1]), c(y[16], y[1], loc[2]), 
         col = cols[16])
     b <- c("E", "N", "W", "S")
     for (i in 0:3) text((size + par("cxy")[1]) * cos(bearing + 
         i * pi/2) + loc[1], (size + par("cxy")[2]) * 
         sin(bearing + i * pi/2) + loc[2], b[i + 1], cex = cex)
 }
 plot(nc)
 northarrow(c(-83, 34), 0.4)
##==============================================================
 l <- list("SpatialPolygonsRescale", layout.north.arrow(), 
     offset = c(-84, 34.1), scale = 0.5)
 spplot(nc.b74, sp.layout = list(l))
##==============================================================
 l1 <- list("SpatialPolygonsRescale", layout.north.arrow(), 
     offset = c(-84, 34.1), scale = 0.5)
 l2 <- list("SpatialPolygonsRescale", layout.scale.bar(), 
     offset = c(-81, 34.1), scale = 1)
 l3 <- list("sp.polygons", nc, col = gray(0.5), fill = "transparent")
 l4 = list("sp.text", c(-81, 34.25), "0", cex = 0.7)
 l5 = list("sp.text", c(-79.9, 34.25), "100 km", cex = 0.7)
 bubble(nc.b74, main = "Proportional symbol map: births, 1974-78", 
     maxsize = 2, sp.layout = list(l1, l2, l3, l4, l5))
##==============================================================
 library(TeachingDemos)
 plot(JP1, xlim = c(128, 146), ylim = c(30, 45), col = gray(0.8))
 subplot({
     plot(JP1, xlim = c(127, 130), ylim = c(25, 30), col = gray(0.8))
     box()
 }, x = c(141.5, 145), y = c(33, 36.5))
##==============================================================
 library(classInt)
 pal1 <- c("wheat1", "red3")
 c1 <- classIntervals(d74, n = 5)
 c1
 plot(c1, pal = pal1, main = "Quantile")
##==============================================================
 plot(classIntervals(d74, n = 5, style = "equal"), pal = pal1, 
     main = "Equal Intervals")
 plot(classIntervals(d74, n = 5, style = "quantile"), 
     pal = pal1, main = "Quantiles")
 set.seed(1)
 plot(classIntervals(d74, n = 5, style = "kmeans"), pal = pal1, 
     main = "K-means")
 plot(classIntervals(d74, n = 5, style = "hclust"), pal = pal1, 
     main = "Hierarchical cluster")
 plot(classIntervals(d74, n = 5, style = "fisher"), pal = pal1, 
     main = "Fisher's method")
##==============================================================
 library(RColorBrewer)
 cols <- brewer.pal(5, "BuPu")
 class <- classIntervals(d74, n = 5, style = "quantile")
 colcode <- findColours(class, cols)
 plot(nc, col = colcode)
 legend(-84, 35, legend = names(attr(colcode, "table")), 
     fill = attr(colcode, "palette"), cex = 0.5, bty = "n")
##==============================================================
 class <- classIntervals(d74, n = 5, style = "equal")
 colcode <- findColours(class, cols)
 plot(nc, col = colcode)
 legend(-84, 35, legend = names(attr(colcode, "table")), 
     fill = attr(colcode, "palette"), cex = 0.5, bty = "n")
##==============================================================
 class <- classIntervals(d74, n = 5, style = "kmeans")
 colcode <- findColours(class, cols)
 plot(nc, col = colcode)
 legend(-84, 35, legend = names(attr(colcode, "table")), 
     fill = attr(colcode, "palette"), cex = 0.5, bty = "n")
##==============================================================
 class <- classIntervals(d74, n = 5, style = "hclust")
 colcode <- findColours(class, cols)
 plot(nc, col = colcode)
 legend(-84, 35, legend = names(attr(colcode, "table")), 
     fill = attr(colcode, "palette"), cex = 0.5, bty = "n")
##==============================================================
 class <- classIntervals(d74, n = 5, style = "fisher")
 colcode <- findColours(class, cols)
 plot(nc, col = colcode)
 legend(-84, 35, legend = names(attr(colcode, "table")), 
     fill = attr(colcode, "palette"), cex = 0.5, bty = "n")
##==============================================================
 class <- classIntervals(d74, n = 5, style = "jenks")
 colcode <- findColours(class, cols)
 plot(nc, col = colcode)
 legend(-84, 35, legend = names(attr(colcode, "table")), 
     fill = attr(colcode, "palette"), cex = 0.5, bty = "n")
##==============================================================
 x <- (0:100)/100
 tau <- 1
 k <- 3/(pi * tau^2) * (1 - x^2/tau^2)^2
 plot(x, k, type = "l", xlab = "distance", ylab = "")
##==============================================================
 library(splancs)
 data(bodmin)
 plot(bodmin$poly, asp = 1, type = "n", axes = FALSE, 
     xlab = "", ylab = "")
 image(kernel2d(as.points(bodmin), bodmin$poly, h0 = 2, 
     nx = 100, ny = 100), add = TRUE, col = terrain.colors(20))
 pointmap(as.points(bodmin), add = TRUE)
 polymap(bodmin$poly, add = TRUE)
##==============================================================
 bodmin.xy <- coordinates(bodmin[1:2])
 apply(bodmin$poly, 2, range)
##==============================================================
 grd1 <- GridTopology(cellcentre.offset = c(-5.2, -11.5), 
     cellsize = c(0.2, 0.2), cells.dim = c(75, 100))
 k100 <- spkernel2d(bodmin.xy, bodmin$poly, h0 = 1, grd1)
 k150 <- spkernel2d(bodmin.xy, bodmin$poly, h0 = 1.5, 
     grd1)
 k200 <- spkernel2d(bodmin.xy, bodmin$poly, h0 = 2, grd1)
 k250 <- spkernel2d(bodmin.xy, bodmin$poly, h0 = 2.5, 
     grd1)
 df <- data.frame(k100 = k100, k150 = k150, k200 = k200, 
     k250 = k250)
 kernels <- SpatialGridDataFrame(grd1, data = df)
 spplot(kernels, checkEmptyRC = FALSE, col.regions = terrain.colors(16), 
     cuts = 15)
##==============================================================
 library(spatialkernel)
 data(lansing)
 data(polyb)
##==============================================================
 ndx <- which(pinpoly(polyb, as.matrix(lansing[c("x", 
     "y")])) > 0)
 pts <- as.matrix(lansing[c("x", "y")])[ndx, ]
 marks <- lansing[["marks"]][ndx]
##==============================================================
 h <- seq(0.02, 0.1, length = 101)
 cv <- cvloglk(pts, marks, h = h)$cv
 hcv <- h[which.max(cv)]
##==============================================================
 plot(h, cv, type = "l")
##==============================================================
 sp <- spseg(pts, marks, hcv, opt = 3, ntest = 1000, poly = polyb)
##==============================================================
 plotphat(sp)
 plotmc(sp, quan = c(0.025, 0.975))
##==============================================================
 sp$pvalue
##==============================================================
 library(splancs)
 data(southlancs)
##==============================================================
 image(kernel2d(southlancs.pts[southlancs$cc == 1, ], 
     poly = southlancs.bdy, h0 = 2500, nx = 200, ny = 200))
 polygon(southlancs.bdy)
##==============================================================
 image(kernel2d(southlancs.pts[southlancs$cc == 0, ], 
     poly = southlancs.bdy, h0 = 2500, nx = 200, ny = 200))
 polygon(southlancs.bdy)
##==============================================================
 surface <- kernrat(pts1 = southlancs.pts[southlancs$cc == 
     1, ], pts2 = southlancs.pts[southlancs$cc == 0, ], 
     poly = southlancs.bdy, h1 = 2500, h2 = 2500, nx = 200, 
     ny = 200)
 image(surface)
 polygon(southlancs.bdy)
##==============================================================
 library(gstat)
 library(maptools)
 library(rgdal)
 data(meuse.grid)
 coordinates(meuse.grid) <- c("x", "y")
 gridded(meuse.grid) <- TRUE
##==============================================================
 proj4string(meuse.grid) <- CRS(paste("+init=epsg:28992", 
     "+towgs84=565.237,50.0087,465.658,-0.406857,0.350733,",
     "-1.87035,4.0812"))
 data(meuse)
 coordinates(meuse) <- c("x", "y")
 proj4string(meuse) <- CRS(proj4string(meuse.grid))
 grd <- as(meuse.grid, "SpatialPolygons")
 proj4string(grd) <- CRS(proj4string(meuse))
 grd.union <- unionSpatialPolygons(grd, rep("x", length(slot(grd, 
     "polygons"))))
 ll <- CRS("+proj=longlat +datum=WGS84")
 grd.union.ll <- spTransform(grd.union, ll)
 llGRD <- GE_SpatialGrid(grd.union.ll)
 llGRD_in <- overlay(llGRD$SG, grd.union.ll)
 llSGDF <- SpatialGridDataFrame(grid = slot(llGRD$SG, 
     "grid"), proj4string = CRS(proj4string(llGRD$SG)), 
     data = data.frame(in0 = llGRD_in))
 llSPix <- as(llSGDF, "SpatialPixelsDataFrame")
 meuse_ll <- spTransform(meuse, CRS("+proj=longlat +datum=WGS84"))
##==============================================================
 llSPix$pred <- idw(log(zinc) ~ 1, meuse_ll, llSPix)$var1.pred
##==============================================================
 png(file = "zinc_IDW.png", width = llGRD$width, height = llGRD$height, 
     bg = "transparent")
 par(mar = c(0, 0, 0, 0), xaxs = "i", yaxs = "i")
 image(llSPix, "pred", col = bpy.colors(20))
 dev.off()
##==============================================================
 kmlOverlay(llGRD, "zinc_IDW.kml", "zinc_IDW.png")
##==============================================================
 library(geoR)
 data(s100)
 class(s100)
##==============================================================
 cloud1 <- variog(s100, option = "cloud", max.dist = 1)
 cloud2 <- variog(s100, option = "cloud", estimator.type = "modulus", 
     max.dist = 1)
 bin1 <- variog(s100, uvec = seq(0, 1, l = 11))
 bin2 <- variog(s100, uvec = seq(0, 1, l = 11),
     estimator.type = "modulus")
 plot(cloud1, main = "classical estimator")
 plot(cloud2, main = "modulus estimator")
 plot(bin1, main = "classical estimator")
 plot(bin2, main = "modulus estimator")
##==============================================================
 bin1 <- variog(s100, uvec = seq(0, 1, l = 11), bin.cloud = TRUE)
 bin2 <- variog(s100, uvec = seq(0, 1, l = 11),
     estimator.type = "modulus", bin.cloud = TRUE)
 par(mfrow = c(1, 2))
 plot(bin1, bin.cloud = TRUE, main = "classical estimator")
 plot(bin2, bin.cloud = TRUE, main = "modulus estimator")
##==============================================================
 vario60 <- variog(s100, max.dist = 1, direction = pi/3)
##==============================================================
 vario.4 <- variog4(s100, max.dist = 1)
##==============================================================
 par(mfrow = c(1, 2))
 plot(vario60)
 title(main = expression(paste("directional, angle = ", 
     60 * degree)))
 plot(vario.4, lwd = 2)
##==============================================================
 bin1 <- variog(s100, uvec = seq(0, 1, l = 11))
 plot(bin1)
 lines.variomodel(cov.model = "exp", cov.pars = c(1, 0.3), 
     nugget = 0, max.dist = 1, lwd = 3)
 smooth <- variog(s100, option = "smooth", max.dist = 1, 
     n.points = 100, kernel = "normal", band = 0.2)
 lines(smooth, type = "l", lty = 2)
 legend(0.4, 0.3, c("empirical", "exponential model", 
     "smoothed"), lty = c(-1, 1, 2), lwd = c(-1, 3, 1), 
     pch = c(1, -1, -1))
##==============================================================
 ml <- likfit(s100, ini = c(1, 0.5))
 class(ml)
 ml
 summary(ml)
##==============================================================
 ml <- likfit(s100, ini = c(1, 0.5), fix.nugget = TRUE)
 reml <- likfit(s100, ini = c(1, 0.5), fix.nugget = TRUE, 
     method = "RML")
 ols <- variofit(bin1, ini = c(1, 0.5), fix.nugget = TRUE, 
     weights = "equal")
 wls <- variofit(bin1, ini = c(1, 0.5), fix.nugget = TRUE)
##==============================================================
 ml.fn <- likfit(s100, ini = c(1, 0.5), fix.nugget = TRUE, 
     nugget = 0.15)
 reml.fn <- likfit(s100, ini = c(1, 0.5), fix.nugget = TRUE, 
     nugget = 0.15, method = "RML")
 ols.fn <- variofit(bin1, ini = c(1, 0.5), fix.nugget = TRUE, 
     nugget = 0.15, weights = "equal")
 wls.fn <- variofit(bin1, ini = c(1, 0.5), fix.nugget = TRUE, 
     nugget = 0.15)
##==============================================================
 ml.n <- likfit(s100, ini = c(1, 0.5), nug = 0.5)
 reml.n <- likfit(s100, ini = c(1, 0.5), nug = 0.5, method = "RML")
 ols.n <- variofit(bin1, ini = c(1, 0.5), nugget = 0.5, 
     weights = "equal")
 wls.n <- variofit(bin1, ini = c(1, 0.5), nugget = 0.5)
##==============================================================
 par(mfrow = c(1, 3))
 plot(bin1, main = expression(paste("fixed ", tau^2 == 
     0)))
 lines(ml, max.dist = 1)
 lines(reml, lwd = 2, max.dist = 1)
 lines(ols, lty = 2, max.dist = 1)
 lines(wls, lty = 2, lwd = 2, max.dist = 1)
 legend(0.5, 0.3, legend = c("ML", "REML", "OLS", "WLS"), 
     lty = c(1, 1, 2, 2), lwd = c(1, 2, 1, 2), cex = 0.7)
 plot(bin1, main = expression(paste("fixed ", tau^2 == 
     0.15)))
 lines(ml.fn, max.dist = 1)
 lines(reml.fn, lwd = 2, max.dist = 1)
 lines(ols.fn, lty = 2, max.dist = 1)
 lines(wls.fn, lty = 2, lwd = 2, max.dist = 1)
 legend(0.5, 0.3, legend = c("ML", "REML", "OLS", "WLS"), 
     lty = c(1, 1, 2, 2), lwd = c(1, 2, 1, 2), cex = 0.7)
 plot(bin1, main = expression(paste("estimated  ", tau^2)))
 lines(ml.n, max.dist = 1)
 lines(reml.n, lwd = 2, max.dist = 1)
 lines(ols.n, lty = 2, max.dist = 1)
 lines(wls.n, lty = 2, lwd = 2, max.dist = 1)
 legend(0.5, 0.3, legend = c("ML", "REML", "OLS", "WLS"), 
     lty = c(1, 1, 2, 2), lwd = c(1, 2, 1, 2), cex = 0.7)
##==============================================================
 loci <- matrix(c(0.2, 0.6, 0.2, 1.1, 0.2, 0.3, 1, 1.1), 
     ncol = 2)
 loci
##==============================================================
 kc4 <- krige.conv(s100, locations = loci, 
     krige = krige.control(obj.m = wls))
 kc4$predict
##==============================================================
 pred.grid <- expand.grid(seq(0, 1, l = 51), seq(0, 1, 
     l = 51))
 kc <- krige.conv(s100, loc = pred.grid, 
     krige = krige.control(obj.m = wls))
 image(kc, loc = pred.grid, col = gray(seq(1, 0.1, l = 30)), 
     xlab = "Coord X", ylab = "Coord Y")
##==============================================================
 kc <- krige.conv(s100, loc = pred.grid,
     krige = krige.control(type.krige = "sk", obj.m = ml))
 image(kc, loc = pred.grid, col = gray(seq(1, 0.1, l = 30)), 
     xlab = "Coord X", ylab = "Coord Y")
 contour(kc, add = TRUE)
##==============================================================
 bin.u <- variog(s100, uvec = seq(0, 1, l = 11), trend = "1st")
 wls.u <- variofit(bin.u, ini = c(0.4, 0.5), nugget = 0.1)
 plot(bin.u)
 lines(wls.u, max.dist = 1)
 kg <- krige.control(trend.d = "1st", trend.l = "1st", 
     obj.m = wls.u)
 kc.u <- krige.conv(s100, loc = pred.grid, krige = kg)
 image(kc.u, loc = pred.grid, col = gray(seq(1, 0.1, l = 30)), 
     xlab = "Coord X", ylab = "Coord Y")
 contour(kc.u, add = TRUE)
##==============================================================
 discontinuous.cartogram <- function(x, v, a, col = 3) {
     x.p <- coordinates(x)
     dn <- sqrt(x@data[, v]/x@data[, a])
     m <- dn/max(dn)
     plot(x)
     for (i in 1:length(x@polygons)) {
         p <- x@polygons[[i]]@Polygons[[1]]@coords
         x.n <- m[i] * (p[, 1] - x.p[i, 1]) + x.p[i, 1]
         y.n <- m[i] * (p[, 2] - x.p[i, 2]) + x.p[i, 2]
         polygon(x.n, y.n, col = col)
     }
 }
 discontinuous.cartogram(nc, "BIR74", "AREA")
##==============================================================
 library(fields)
 nc.p <- coordinates(nc)
 out <- predict.surface(Krig(nc.p, nc@data$BIR74, theta = 20))
 z.m <- mean(out$z, na.rm = TRUE)
 out$z[is.na(out$z)] <- z.m
##==============================================================
 library(Rcartogram)
 g <- cartogram(out$z)
 predict(g, c(3.1, 3, 2), c(4.5, 4.6))
 p <- sapply(nc@polygons, function(x) {
     return(x@Polygons[[1]]@coords)
 })
 x1 <- out$x[1]
 y1 <- out$y[1]
 x.w <- out$x[2] - x1
 y.w <- out$y[2] - y1
 xy.new <- lapply(p, function(x) {
     c1 <- predict(g, (x[, 1] - x1)/x.w, (x[, 2] - y1)/y.w)
     return(cbind(c1$x * x.w + x1, c1$y * y.w + y1))
 })
 plot(t(bbox(nc)), type = "n", axes = FALSE, xlab = "", 
     ylab = "", asp = 1)
 sapply(xy.new, polygon)
##==============================================================
 library(spdep)
 res <- choynowski(nc@data$SID74, nc@data$BIR74)
 lt005 <- (res$pmap < 0.05) & (res$type)
 ge005 <- (res$pmap < 0.05) & (!res$type)
 cols <- rep("white", length(lt005))
 cols[lt005] <- grey(2/7)
 cols[ge005] <- grey(5/7)
 plot(nc, col = cols)
 legend("bottomleft", fill = grey(c(2, 5)/7), legend = c("low", 
     "high"), bty = "n")
##==============================================================
 library(DCluster)
 O <- nc@data$SID74
 E <- nc@data$BIR74 * sum(nc@data$SID74)/sum(nc@data$BIR74)
 smth <- empbaysmooth(O, E)
 smr <- O/E
##==============================================================
 library(RColorBrewer)
 op <- par(no.readonly = TRUE)
 par(mfrow = c(1, 2))
 cols <- brewer.pal(5, "RdYlBu")
 brks <- c(0, 0.5, 1, 1.5, 3, 6)
 plot(nc, col = cols[findInterval(smr, brks)])
 title(main = "SMR")
 legend("bottomleft", fill = cols, legend = leglabs(brks), 
     bty = "n")
 plot(nc, col = cols[findInterval(smth$smthrr, brks)])
 title(main = "EBSMR")
 par(op)
##==============================================================
 plot(nc@data$BIR74, smr, xlab = "Births in 1974-78", 
     ylab = "SMR")
 points(nc@data$BIR74, smth$smthrr, pch = 19)
 legend("topright", c("SMR", "EBSMR"), pch = c(1, 19), 
     bty = "n")
##==============================================================
 library(glmmBUGS)
 data(ontario)
 head(ontario)
##==============================================================
 data(popDataAdjMat)
 class(popDataAdjMat)
 forBugs <- glmmBUGS(formula = observed + logExpected ~ 
     1, spatial = popDataAdjMat, effects = "CSDUID", family = "poisson", 
     data = ontario)
##==============================================================
 library(RColorBrewer)
 library(maps)
 library(cluster)
 palette(brewer.pal(3, "Accent"))
 x <- state.x77[, -c(1:2, 7:8)]
 pamr <- pam(x, k = 3)
 pamc <- pamr$clustering
##==============================================================
 clusplot(pamr, color = TRUE, col.clus = 1:3, shade = TRUE, 
     axes = FALSE)
##==============================================================
 si <- silhouette(pamr)
 plot(si, do.n.k = FALSE, col = si[, 1], do.clus.stat = FALSE)
##==============================================================
 map("state", regions = names(pamc), boundary = FALSE, 
     lty = 1, lwd = 1, col = pamc, fill = T)
 legend("bottomleft", legend = paste("group", 1:3), fill = 1:3, 
     bty = "n")
 title("Cluster analysis on state.x77 data", cex.main = 2, 
     font.main = 3, col.main = "orange", line = 1)
 mtext(paste("variables : ", paste(colnames(x), collapse = ", ")), 
     line = 0, cex = 0.8, side = 3)
##==============================================================
 palette("default")
