##==============================================================
##                            3
##==============================================================
 library(splancs)
 data(cardiff)
 polymap(cardiff$poly, xlab = "Easting", ylab = "Northing")
 points(cardiff$x, cardiff$y, pch = 19)
 polymap(cardiff$poly, xlab = "Easting", ylab = "Northing")
 points(csr(cardiff$poly, length(cardiff$x)), pch = 1)
##==============================================================
 data(cardiff)
 s <- seq(2, 30, 2)
 UL.khat <- Kenv.csr(length(cardiff$x), cardiff$poly, 
     nsim = 99, s = s)
 plot(s, sqrt(khat(as.points(cardiff), cardiff$poly, s = s)/pi) - 
     s, type = "l", xlab = "h", ylim = c(-1, 1.5), 
     ylab = "Estimated L function and simulation envelope")
 lines(s, sqrt(UL.khat$upper/pi) - s, lty = 2)
 lines(s, sqrt(UL.khat$lower/pi) - s, lty = 2)
##==============================================================
 data(okwhite)
 data(okblack)
 okpoly <- list(x = c(okwhite$x, okblack$x), y = c(okwhite$y, 
     okblack$y))
 okpoly.bb <- bboxx(bbox(as.points(okpoly)))
 s <- seq(5, 80, 5)
 K1.hat <- khat(as.points(okwhite), okpoly.bb, s)
 K2.hat <- khat(as.points(okblack), okpoly.bb, s)
 K.diff <- K1.hat - K2.hat
 plot(s, K.diff, xlab = "distance", ylab = expression(hat(K)[1] - 
     hat(K)[2]), ylim = c(-11000, 7000), type = "l",
     main = "Simulation envelopes, random labelling")
 env.lab <- Kenv.label(as.points(okwhite), as.points(okblack), 
     okpoly.bb, nsim = 99, s = s)
 lines(s, env.lab$upper, lty = 2)
 lines(s, env.lab$lower, lty = 2)
##==============================================================
 library(spdep)
 nc.nb <- poly2nb(nc)
##==============================================================
 nb2listw(nc.nb, style = "B")
##==============================================================
 nc.c <- coordinates(nc)
 nc.tri.nb <- tri2nb(nc.c)
##==============================================================
 nc.knn.nb <- knn2nb(knearneigh(nc.c, k = 3))
##==============================================================
 nc.dn.nb <- dnearneigh(nc.c, d1 = 0, d2 = 40, longlat = TRUE)
##==============================================================
 plot(nc, border = "grey")
 plot(nc.tri.nb, nc.c, col = "red", add = TRUE)
 plot(nc, border = "grey")
 plot(nc.tri.nb, nc.c, col = "red", add = TRUE)
 plot(nc, border = "grey")
 plot(nc.knn.nb, nc.c, col = "red", add = TRUE)
 plot(nc, border = "grey")
 plot(nc.dn.nb, nc.c, col = "red", add = TRUE)
##==============================================================
 diffs <- diffnb(nc.nb, nc.knn.nb)
 plot(nc, border = "grey")
 plot(diffs, nc.c, col = "red", add = TRUE)
##==============================================================
 s <- nc@data$SID74/nc@data$BIR74 * 1e+05
 moran.test(s, nb2listw(nc.knn.nb))
##==============================================================
 geary.test(s, nb2listw(nc.nb, style = "B"))
##==============================================================
 lmo <- localmoran(s, nb2listw(nc.nb, style = "B"))
 head(lmo)
##==============================================================
 moran.plot(s, nb2listw(nc.nb, style = "B"))
##==============================================================
 library(DCluster)
##==============================================================
 Observed <- nc@data$SID74
 Expected <- nc@data$BIR74 * sum(nc@data$SID74)/sum(nc@data$BIR74)
 Population <- nc@data$BIR74
 dat <- data.frame(Observed, Expected, Population)
 summary(dat)
##==============================================================
 xy <- coordinates(nc)
 d <- spDistsN1(xy, xy[1, ], longlat = TRUE)
 i <- order(d)
##==============================================================
 kullnagar.stat(dat[i, ], fractpop = 0.5)
##==============================================================
 xy1 <- as.data.frame(xy)
 names(xy1) <- c("x", "y")
 kn.p <- opgam(cbind(dat, xy1), thegrid = xy1, alpha = 0.02, 
     iscluster = kn.iscluster, fractpop = 0.15, R = 999, 
     model = "poisson", mle = calculate.mle(dat, model = "poisson"))
 kn.p
##==============================================================
 x.glm <- glm(Observed ~ 1 + offset(log(Expected)), data = dat, 
     family = "poisson")
 x.nb <- glm.nb(Observed ~ 1 + offset(log(Expected)), 
     data = dat)
 test.nb.pois(x.nb, x.glm)
##==============================================================
 kn.nb <- opgam(cbind(dat, xy1), thegrid = xy1, alpha = 0.02, 
     iscluster = kn.iscluster, fractpop = 0.15, R = 999, 
     model = "negbin", mle = calculate.mle(dat, model = "negbin"))
##==============================================================
 class(kn.nb)
 coordinates(kn.nb) <- ~x + y
 class(kn.nb)
##==============================================================
 k <- which.min(kn.nb$pvalue)
 k
 j <- overlay(kn.nb[k, ], nc)
 j
 nc@data$NAME[j]
##==============================================================
 i <- rank(spDistsN1(xy, xy[j, ], longlat = TRUE))
 plot(nc)
 plot(nc[i < kn.nb$size[k], ], col = "red", add = TRUE)
 plot(kn.nb[k, ], pch = 19, cex = 2, add = TRUE)
##==============================================================
 v <- kn.nb$pvalue
 v[which.min(v)] <- NA
 k <- which.min(v)
 k
##==============================================================
 j <- overlay(kn.nb[k, ], nc)
 nc@data$NAME[j]
##==============================================================
 i <- rank(spDistsN1(xy, xy[j, ], longlat = TRUE))
 plot(nc)
 plot(nc[i < kn.nb$size[k], ], col = "red", add = TRUE)
 plot(kn.nb[k, ], pch = 19, cex = 2, add = TRUE)
##==============================================================
 j <- overlay(kn.nb, nc)
 j
##==============================================================
 find.row <- function(j, s) {
     i <- rank(spDistsN1(xy, xy[j, ], longlat = TRUE))
     return(i < s)
 }
##==============================================================
 clst <- mapply(find.row, j, as(kn.nb, "data.frame")[, 
     6])
 clst2 <- as.logical(rowSums(clst))
##==============================================================
 cols <- rep("white", length(clst2))
 cols[clst2] <- "red"
 plot(nc, col = cols)
##==============================================================
 p1 <- kn.nb[order(kn.nb@data$pvalue), ]
 plot(p1, pch = 19, col = "white", cex = 1.8, add = TRUE)
 plot(p1, pch = as.character(1:nrow(p1)), add = TRUE)
##==============================================================
 library(splancs)
 data(southlancs)
##==============================================================
 d <- dsquare(southlancs.pts, old.incinerator)
##==============================================================
 larynx <- sum(southlancs.cc)
 lung <- length(southlancs.cc) - larynx
 r <- larynx/lung
##==============================================================
 result <- tribble(ccflag = southlancs.cc, vars = d, alphas = 10, 
     betas = 10, rho = r)
##==============================================================
 print.ribfit(result)
##==============================================================
 library(DCluster)
 dat2 <- cbind(dat, xy1)
 i <- which(as(nc, "data.frame")["NAME"] == "Robeson")
 stone.stat(dat2, region = i, lambda = 1)
##==============================================================
 stone.test(Observed ~ offset(log(Expected)), data = dat2, 
     model = "poisson", R = 99, region = i, lambda = 1)
