##==============================================================
##                            4
##==============================================================
 library(maptools)
 pts <- cbind(c(8, 8.2, 4, 4.2), c(5.5, 4, 5, 4))
 plot(pts, cex = 5, pch = 19, col = "#00CCFF", xlim = c(0, 
     10), ylim = c(0, 8), axes = FALSE, xlab = "", ylab = "")
 pointLabel(pts, labels = LETTERS[1:4], cex = 3)
 arrows(pts[1, 1], pts[1, 2], pts[2, 1], pts[2, 2], lwd = 3, 
     col = "#003399", code = 3)
##==============================================================
 d <- sqrt((pts[1, 1] - pts[2, 1])^2 + (pts[1, 2] - pts[2, 
     2])^2)
 pointLabel(sum(pts[1:2, 1])/2, sum(pts[1:2, 2])/2,
     labels = as.character(round(d, 2)), cex = 2)
##==============================================================
 l.x <- c(9.38, 9.08, 8.44, 8, 6.97, 5.05, 4, 2.49, 2.15, 
     2.15, 2.41, 3.37, 4.2, 6.48, 8.2, 8.93, 9.04, 8.68, 
     8.36, 8.14)
 l.y <- c(6.68, 6.03, 5.56, 5.5, 5.41, 5.09, 5, 4.61, 
     4.33, 4.13, 3.89, 3.86, 4, 3.96, 4, 3.62, 3.2, 2.75, 
     2.58, 2.41)
##==============================================================
 plot(l.x, l.y, type = "l", lwd = 30, col = "#003399", 
     axes = FALSE, xlab = "", ylab = "")
 points(pts, col = "#00CCFF", pch = 19, cex = 5)
 pointLabel(pts, labels = LETTERS[1:4], cex = 3)
##==============================================================
 plot(l.x, l.y, type = "l", lwd = 30, col = "#003399", 
     axes = FALSE, xlab = "", ylab = "")
 points(pts, col = "#00CCFF", pch = 19, cex = 5)
 text(l.x, l.y, as.character(1:20))
##==============================================================
 lab.x <- l.x[4:15]
 lab.y <- l.y[4:15]
 lac.x <- l.x[4:7]
 lac.y <- l.y[4:7]
 n.ab <- sum(sqrt((diff(lab.x))^2 + (diff(lab.y))^2))
 n.ac <- sum(sqrt((diff(lac.x))^2 + (diff(lac.y))^2))
 n.ab
 n.ac
##==============================================================
 d.ab <- d
 d.ac <- sqrt((pts[1, 1] - pts[3, 1])^2 + (pts[1, 2] - 
     pts[3, 2])^2)
 d.ab
 d.ac
 n.ab - d.ab
 n.ab/d.ab
 n.ac - d.ac
 n.ac/d.ac
##==============================================================
 node <- cbind(c(7.31, 26.63, 69.45, 37.86, 19.32, 39.43, 
     90.86), c(51.52, 69.7, 51.95, 50.22, 28.57, 27.71, 
     50.65))
 row.names(node) <- LETTERS[1:7]
 node
##==============================================================
 library(maptools)
 mkdemoline <- function(from, to, mid = NULL) {
     id <- paste(from, to, sep = "")
     l <- Lines(Line(rbind(node[from, ], mid, node[to, 
         ])), ID = id)
     return(l)
 }
 AB <- mkdemoline("A", "B", rbind(c(23.76, 67.97), c(25.59, 
     69.26)))
 AD <- mkdemoline("A", "D", rbind(c(11.23, 52.81), c(33.68, 
     50.22)))
 AE <- mkdemoline("A", "E", rbind(c(14.1, 41.13), c(13.32, 
     35.5), c(9.92, 34.2)))
 BD <- mkdemoline("B", "D", c(28.72, 61.04))
 DE <- mkdemoline("D", "E", rbind(c(35.77, 46.75), c(36.81, 
     45.45), c(21.67, 30.3)))
 BC <- mkdemoline("B", "C", rbind(c(30.55, 67.53), c(53.26, 
     55.41)))
 DC <- mkdemoline("D", "C", c(47, 48.92))
 EF <- mkdemoline("E", "F")
 CG <- mkdemoline("C", "G", rbind(c(87.21, 51.52), c(90.34, 
     51.95)))
 FC <- mkdemoline("F", "C", rbind(c(44.91, 33.33), c(45.95, 
     35.93), c(47, 37.23)))
 FG <- mkdemoline("F", "G", rbind(c(60.57, 34.63), c(72.85, 
     41.13)))
 l.sp <- SpatialLines(list(AB, AD, AE, BD, DE, BC, DC, 
     EF, CG, FC, FG))
##==============================================================
 d <- sapply(coordinates(l.sp), function(x) {
     sum(sqrt((diff(x[[1]][, 1]))^2 + (diff(x[[1]][, 2]))^2))
 })
 names(d) <- c("AB", "AD", "AE", "BD", "DE", "BC", "DC", 
     "EF", "CG", "FC", "FG")
 round(d, 1)
##==============================================================
 d.xy <- sapply(coordinates(l.sp), function(x) {
     v <- x[[1]]
     n <- length(v[, 1])
     return(c((v[n, 1] + v[1, 1])/2, (v[n, 2] + v[1, 2])/2))
 })
##==============================================================
 plot(l.sp)
 points(node, pch = 19)
 pointLabel(node, LETTERS[1:7])
 pointLabel(t(d.xy), as.character(round(d, 1)))
##==============================================================
 s <- "A"
 T <- c(0, rep(Inf, 6))
 p <- rep(0, 7)
 B <- rep(0, 7)
 N <- LETTERS[1:7]
 M <- N[N != s]
 r <- data.frame(T, p, B)
 row.names(r) <- N
##==============================================================
 r
 M
##==============================================================
 i <- "A"
 j <- "B"
 l <- paste(i, j, sep = "")
 x <- r[i, "T"] + d[l]
 if (min(r[j, "T"], x) == x) {
     r[j, "T"] <- x
     r[j, "B"] <- i
 }
##==============================================================
 if (min(r[j, "T"], r[i, "T"] + d[l]) == r[i, "T"] + d[l]) {
     r[j, "T"] <- r[i, "T"] + d[l]
     r[j, "B"] <- i
 }
##==============================================================
 i <- "A"
 j <- "D"
 l <- paste(i, j, sep = "")
 x <- r[i, "T"] + d[l]
 if (min(r[j, "T"], x) == x) {
     r[j, "T"] <- x
     r[j, "B"] <- i
 }
##==============================================================
 i <- "A"
 j <- "E"
 l <- paste(i, j, sep = "")
 x <- r[i, "T"] + d[l]
 if (min(r[j, "T"], x) == x) {
     r[j, "T"] <- x
     r[j, "B"] <- i
 }
##==============================================================
 x <- r[M, ]
 y <- M[which.min(x$T)]
 r[y, "p"] <- y
 M <- M[M != y]
##==============================================================
 r
 M
##==============================================================
 cols <- rep("black", 11)
 cols[1] <- "red"
 lwds <- rep(1, 11)
 lwds[1] <- 4
 plot(l.sp, col = cols, lwd = lwds)
 points(node, pch = 19)
 pointLabel(node, LETTERS[1:7])
##==============================================================
 i <- "B"
 j <- "C"
 l <- paste(i, j, sep = "")
 x <- r[i, "T"] + d[l]
 if (min(r[j, "T"], x) == x) {
     r[j, "T"] <- x
     r[j, "B"] <- i
 }
##==============================================================
 x <- r[M, ]
 y <- M[which.min(x$T)]
 r[y, "p"] <- y
 M <- M[M != y]
##==============================================================
 r
 M
##==============================================================
 cols[2] <- "red"
 lwds[2] <- 4
 plot(l.sp, col = cols, lwd = lwds)
 points(node, pch = 19)
 pointLabel(node, LETTERS[1:7], cex = 2)
##==============================================================
 i <- "D"
 j <- "C"
 l <- paste(i, j, sep = "")
 x <- r[i, "T"] + d[l]
 if (min(r[j, "T"], x) == x) {
     r[j, "T"] <- x
     r[j, "B"] <- i
 }
##==============================================================
 x <- r[M, ]
 y <- M[which.min(x$T)]
 r[y, "p"] <- y
 M <- M[M != y]
##==============================================================
 r
 M
##==============================================================
 i <- "E"
 j <- "F"
 l <- paste(i, j, sep = "")
 x <- r[i, "T"] + d[l]
 if (min(r[j, "T"], x) == x) {
     r[j, "T"] <- x
     r[j, "B"] <- i
 }
##==============================================================
 x <- r[M, ]
 y <- M[which.min(x$T)]
 r[y, "p"] <- y
 M <- M[M != y]
##==============================================================
 r
 M
##==============================================================
 i <- "F"
 j <- "G"
 l <- paste(i, j, sep = "")
 x <- r[i, "T"] + d[l]
 if (min(r[j, "T"], x) == x) {
     r[j, "T"] <- x
     r[j, "B"] <- i
 }
##==============================================================
 x <- r[M, ]
 y <- M[which.min(x$T)]
 r[y, "p"] <- y
 M <- M[M != y]
##==============================================================
 r
 M
##==============================================================
 i <- "C"
 j <- "G"
 l <- paste(i, j, sep = "")
 x <- r[i, "T"] + d[l]
 if (min(r[j, "T"], x) == x) {
     r[j, "T"] <- x
     r[j, "B"] <- i
 }
##==============================================================
 x <- r[M, ]
 y <- M[which.min(x$T)]
 r[y, "p"] <- y
 M <- M[M != y]
##==============================================================
 r
 M
##==============================================================
 library(igraph)
 f <- sapply(names(d), function(x) {
     substr(x, 1, 1)
 })
 t <- sapply(names(d), function(x) {
     substr(x, 2, 2)
 })
 g1 <- data.frame(from = f, to = t)
 g2 <- graph.data.frame(g1, directed = FALSE,
     vertices = data.frame(LETTERS[1:7]))
 E(g2)$weight <- d
 g2
##==============================================================
 plot(g2, layout = node, vertex.label = V(g2)$name,
     edge.label = round(E(g2)$weight, 1))
##==============================================================
 V(g2)
 sp <- get.shortest.paths(g2, from = 0, to = 6)
 V(g2)$name[unlist(sp) + 1]
 spv <- shortest.paths(g2, v = 0)
 spv[unlist(sp) + 1]
##==============================================================
 V(g2)$color <- "lightblue"
 V(g2)$color[(unlist(sp) + 1)] <- "red"
 E(g2)$width <- 1
 E(g2, path = unlist(sp))$width <- 3
 plot(g2, layout = node, vertex.label = V(g2)$name, 
     edge.label = round(E(g2)$weight, 1))
