##==============================================================
##                            5
##==============================================================
 library(spdep)
##==============================================================
 data(oldcol)
 names(COL.OLD)
##==============================================================
 COL.ols <- lm(CRIME ~ INC + HOVAL, data = COL.OLD)
 summary(COL.ols)
##==============================================================
 W <- nb2listw(COL.nb, style = "W")
 lm.LMtests(COL.ols, listw = W, test = c("LMlag", "LMerr"))
##==============================================================
 COL.ar <- lagsarlm(CRIME ~ 1, data = COL.OLD, listw = W, 
     method = "eigen")
 class(COL.ar)
##==============================================================
 summary(COL.ar)
##==============================================================
 op <- par(no.readonly = TRUE)
 par(mfrow = c(2, 1))
 plot(COL.OLD$CRIME, type = "l")
 lines(fitted(COL.ar), lty = 2)
 legend("topright", c("Actual", "Predicted"), lty = 1:2, 
     bty = "n")
 title(main = "Spatial AR Model   Actual vs. Predicted")
 plot(residuals(COL.ar), type = "l", xlab = "", ylab = "", 
     main = "Residuals")
 par(op)
##==============================================================
 COL.sar <- lagsarlm(CRIME ~ INC + HOVAL, data = COL.OLD, 
     listw = W, method = "eigen")
 class(COL.sar)
##==============================================================
 summary(COL.sar)
##==============================================================
 op <- par(no.readonly = TRUE)
 par(mfrow = c(2, 1))
 plot(COL.OLD$CRIME, type = "l", main = "SEM  Actual vs. Predicted")
 lines(fitted(COL.sar), lty = 2)
 legend("topright", c("Actual", "Predicted"), lty = 1:2, 
     bty = "n")
 plot(residuals(COL.sar), type = "l", xlab = "", ylab = "", 
     main = "Residuals")
 par(op)
##==============================================================
 COL.sem <- errorsarlm(CRIME ~ INC + HOVAL, data = COL.OLD, 
     listw = W, method = "eigen")
##==============================================================
 summary(COL.sem)
##==============================================================
 op <- par(no.readonly = TRUE)
 par(mfrow = c(2, 1))
 plot(COL.OLD$CRIME, type = "l", main = "SEM  Actual vs. Predicted")
 lines(fitted(COL.sem), lty = 2)
 legend("topright", c("Actual", "Predicted"), lty = 1:2, 
     bty = "n")
 plot(residuals(COL.sem), type = "l", xlab = "", ylab = "", 
     main = "Residuals")
 par(op)
##==============================================================
 COL.sdm <- lagsarlm(CRIME ~ INC + HOVAL, data = COL.OLD, 
     listw = W, type = "mixed")
 class(COL.sdm)
##==============================================================
 summary(COL.sdm)
##==============================================================
 op <- par(no.readonly = TRUE)
 par(mfrow = c(2, 1))
 plot(COL.OLD$CRIME, type = "l", main = "SDM  Actual vs. Predicted")
 lines(fitted(COL.sdm), lty = 2)
 legend("topright", c("Actual", "Predicted"), lty = 1:2, 
     bty = "n")
 plot(residuals(COL.sdm), type = "l", xlab = "", ylab = "", 
     main = "Residuals")
 par(op)
##==============================================================
 anova(COL.ar, COL.sar, COL.sem, COL.sdm, COL.ols)
##==============================================================
 COL.car <- spautolm(CRIME ~ INC + HOVAL, data = COL.OLD, 
     family = "CAR", listw = W)
 class(COL.car)
##==============================================================
 summary(COL.car)
##==============================================================
 op <- par(no.readonly = TRUE)
 par(mfrow = c(2, 1))
 plot(COL.OLD$CRIME, type = "o", main = "CAR  Actual vs. Predicted")
 lines(fitted(COL.car), lty = 2)
 legend("topright", c("Actual", "Predicted"), lty = 1:2, 
     bty = "n")
 plot(residuals(COL.car), type = "l", xlab = "", ylab = "", 
     main = "Residuals")
 par(op)
##==============================================================
 library(spdep)
 columbus <- readShapeSpatial(system.file("etc/shapes/columbus.shp", 
     package = "spdep")[1])
 col.gal.nb <- read.gal(system.file("etc/weights/columbus.gal", 
     package = "spdep")[1])
 names(columbus)
 xy <- cbind(columbus$X, columbus$Y)
##==============================================================
 ac1 <- autocov_dist(columbus$CRIME, xy, nbs = 10, style = "W", 
     type = "one")
 acinv <- autocov_dist(columbus$CRIME, xy, nbs = 10, style = "W", 
     type = "inverse")
 acinv2 <- autocov_dist(columbus$CRIME, xy, nbs = 10, 
     style = "W", type = "inverse.squared")
##==============================================================
 summary(columbus$CRIME)
 summary(ac1)
##==============================================================
 res1 <- glm(CRIME ~ HOVAL + ac1, data = columbus, family = "gaussian")
 res1
##==============================================================
 AIC(glm(CRIME ~ HOVAL + acinv, data = columbus, family = "gaussian"))
 AIC(glm(CRIME ~ HOVAL + acinv2, data = columbus, family = "gaussian"))
##==============================================================
 library(spgwr)
 data(georgia)
##==============================================================
 summary(gSRDF["PctBach"])
##==============================================================
 g.gauss <- gwr.sel(PctBach ~ TotPop90 + PctRural + PctEld + 
     PctFB + PctPov + PctBlack, gweight = gwr.Gauss, data = gSRDF)
 g.gauss
##==============================================================
 gwr.sel(PctBach ~ TotPop90 + PctRural + PctEld + PctFB + 
     PctPov + PctBlack, gweight = gwr.gauss, data = gSRDF)
 gwr.sel(PctBach ~ TotPop90 + PctRural + PctEld + PctFB + 
     PctPov + PctBlack, gweight = gwr.tricube, data = gSRDF)
##==============================================================
 res <- gwr(PctBach ~ TotPop90 + PctRural + PctEld + PctFB + 
     PctPov + PctBlack, data = gSRDF, bandwidth = g.gauss)
 res
##==============================================================
 str(res, max.level = 1)
 str(res$SDF@data)
##==============================================================
 brks <- c(-0.25, 0, 0.01, 0.025, 0.075)
 cols <- grey(5:2/6)
 plot(res$SDF, col = cols[findInterval(res$SDF$PctBlack, 
     brks, all.inside = TRUE)])
 legend("bottomleft", leglabs(brks), fill = cols, bty = "n")
##==============================================================
 res$lm$coefficients["PctBlack"]
##==============================================================
 g.adapt.gauss <- gwr.sel(PctBach ~ TotPop90 + PctRural + 
     PctEld + PctFB + PctPov + PctBlack, data = gSRDF, 
     adapt = TRUE)
 res.adpt <- gwr(PctBach ~ TotPop90 + PctRural + PctEld + 
     PctFB + PctPov + PctBlack, data = gSRDF, adapt = g.adapt.gauss)
 res.adpt
##==============================================================
 res <- gwr(PctBach ~ TotPop90 + PctRural + PctEld + PctFB + 
     PctPov + PctBlack, data = gSRDF, bandwidth = g.gauss, 
     hatmatrix = TRUE)
 LMZ.F3GWR.test(res)
